#include "dHeap.h"
#include <stdlib.h>
#include <stdio.h>
#include "types.h"

int *dijkstra_solve(Node *array, int n, int s_index, int d)
{
    HeapPtr *ptr; 
    int counter; 

    int *up = (int *)calloc(n, sizeof(int ));
    
    ptr = HeapInit(n, d);

    array[s_index].SKP = 0;

    for(counter = 0; counter < n; counter++)
       HeapInsert(ptr, array+counter); 

    while(ptr -> nodes_n > 0)
    {
        Node *currNode = getMin(ptr);

        int limit = currNode -> edges_num;
        int edge_index;
        Edge *curr = currNode -> edges -> next;

        while(curr != NULL)
        {
            int path_weight = (curr -> weight) + (currNode -> SKP);

            if(curr -> to -> SKP > path_weight)
            {
                relaxSKP(ptr, curr -> to -> index, path_weight);
                up[currNode->graph_index] = currNode -> graph_index;
            }

            curr = curr -> next;
       }
    }

    return up;
}
