#include "dijkstra.h"
#include <stdio.h>

using namespace std;

void dijkstraSolve(Graph &net, uint8_t start_index, uint8_t end_index, std::vector<pair<int,int> > &fastest_path)
{
    NodesQueue NodeQueue;
    vector<NodeHandle> handles;

    net[0].KMC = 0; 
    net[0].parrent_road_type = 0;
    net[0].parrent_index = 0;

    for(int i = 0; i < net.size(); i++)
    {
        handles.push_back(NodeQueue.push(net[i]));
        Node top = NodeQueue.top();
    }


    while(!NodeQueue.empty())
    {
        Node node = NodeQueue.top();
        NodeQueue.pop();

        for(int i = 0; i < node.roads.size(); i++)
        {
            float weight = node.roads[i].cost;
            weight += node.roads[i].type == node.parrent_road_type ? 0: weight*0.1;
            weight += node.KMC;
            NodeHandle nodeTo = handles[node.roads[i].to];
            int KMC = (*nodeTo).KMC;

            if(weight < (*nodeTo).KMC)
            {
                (*nodeTo).KMC = weight;
                net[node.roads[i].to].parrent_index = node.roads[i].from;
                net[node.roads[i].to].parrent_road_type = node.roads[i].type;
                net[node.roads[i].to].KMC = weight;

                NodeQueue.decrease(nodeTo);
            }
        }
    }

   int index = end_index;
   do
   {
       int parrent_index = net[index].parrent_index;
       fastest_path.push_back(make_pair(parrent_index, index));
       index = parrent_index;
   }while(index != start_index);
}
