#include "dijkstra.h"
#include <cstdio>
#define FILE_IN "net_in.txt"

using namespace std;

void printRoad(std::vector<pair<int,int> > &road);

int main()
{
    FILE *in = fopen(FILE_IN, "r");

    char buff[32];
    int n,m;

    fgets(buff,32, in);
    sscanf(buff, "%d", &n);

    fgets(buff,32, in);
    sscanf(buff, "%d", &m);

    Graph net;

    for(int i = 0; i < n; i++)
        net.push_back(Node(INF));

    for(int i = 0; i < m; i++)
    {
        int from,to, type;
        float cost;
        fgets(buff, 32, in);
        sscanf(buff, "%d %d %d %f", &from, &to, &type, &cost);

        net[from].roads.push_back(Road(from, to, type, cost));
        net[to].roads.push_back(Road(to, from, type, cost));
    }

    int a,b;
    fgets(buff, 32, in);
    sscanf(buff, "%d %d", &a, &b);

    vector<pair<int,int> > result; 

    dijkstraSolve(net, a, b, result);

    reverse(result.begin(), result.end());
    printRoad(result);

    printf("\n\n%f", net[b].KMC);
}

void printRoad(vector<pair<int, int> > &road)
{
    for(int i = 0; i < road.size(); i++)
    {
        printf("Road from %d to %d\n", road[i].first, road[i].second);
    }
}
