#include <vector>
#include <stdlib.h>
#include "types.h"

using namespace std;

void DFS(int index, Graph &graph, vector<bool> &use)
{
    use[index] = true;

    for(int i = 0; i < graph[index].size(); i++)
    {
        int gIndex = graph[index][i].first.second;
        if(!use[gIndex])
            DFS(gIndex, graph, use);
    }
}

vector<Edge> GenGraph(int nodes_n, int edges_num, int up)
{
    Graph graph(nodes_n);
    vector<bool> use(nodes_n, 0);
    vector<int>  unreach_indexes;
    vector<Edge> result(edges_num);
    int i;


    for(i = 0; i < edges_num; i++)
    {
        int rand_index = rand() % nodes_n;

        Edge new_edge(make_pair(rand_index, rand() % nodes_n), rand() % up + 1);
        graph[rand_index].push_back(new_edge);
    }

    for(i = 0; i < nodes_n; i++)
    {
        if(!use[i])
        {
            DFS(i, graph, use);
            unreach_indexes.push_back(i);
        }
    }

    for(i = 0; i < unreach_indexes.size() - 1; i++)
    {
        for(int j = i + 1; j < unreach_indexes.size(); j++)
        {
            int fst_index = unreach_indexes[i];
            int snd_index = unreach_indexes[j];

            graph[fst_index].push_back(Edge(make_pair(fst_index,snd_index), rand() % up + 1));
            graph[snd_index].push_back(Edge(make_pair(snd_index,fst_index), rand() % up + 1));
        }
    }

    for(i = 0; i < nodes_n; i++)
    {
        vector<Edge> edges = graph[i];

        for(int j = 0; j < edges.size(); j++)
        {
            result.push_back(edges[i]);
        }
    }
    return result;
}
