#include <limits.h>
#include <stdlib.h>
#include "types.h"
#define INF INT_MAX-200

Edge *solvePrim(Node *array, int n)
{
    Edge *edges_KM = (Edge *)calloc(n, sizeof(Edge));
    int i;

    for(i = 0; i < n; i++)
    {
        array[i].used = 0;
        edges_KM[i].weight = INF;
        edges_KM[i].to = i;
    }
    edges_KM[0].weight = 0;

    for(i = 0; i < n; ++i)
    {
        int min_index = -1;
        int j;

        for(j = 0; j < n; ++j)
            if(array[j].used != 1 && (min_index == -1 || edges_KM[j].weight < edges_KM[min_index].weight))
                min_index = j;

        array[min_index].used = 1;

        Edge *edges = array[min_index].edges;
        int limit = array[min_index].n;

        for(j = 0; j < limit; ++j)
        {
            if(edges[j].weight < edges_KM[min_index].weight)
            {
                edges_KM[min_index].weight = edges[j].weight;
                edges_KM[min_index].to     = edges[j].to;
            }
        }
    }

    return edges_KM;
}
