#include "types.h"
#include <vector>
#include <limits.h>

#define MIN(x,y) (x>y)?y:x
#define INF INT_MAX

using namespace std;

int findPath(Graph &net, vector<bool> &visited, int node, int sink, int flow) //findPath based on DFS
{
    printf("DFS here: %d Oo \n", node);
    if(node == sink)
        return flow;

    visited[node] = true;

    for(int i = 0; i < net[node].size(); i++)
    {
        Edge &curr = *(&net[node][i]);
        if(!visited[curr.to] && curr.capacity > curr.flow)
        {
            int min = MIN(flow, curr.capacity-curr.flow);
            int df = findPath(net, visited, curr.to, sink, min);
            if(df > 0)
            {
                curr.flow += df;

                //back edge
                for(int j = 0; j < net[curr.to].size(); ++j)
                {
                    if(net[curr.to][j].to == curr.from)
                    {
                        net[curr.to][j].flow -= df;
                        break;
                    }
                }

                return df;
            }
        }
    }
    return 0;
}

int getMaxFlow(Graph &net, int source, int sink)
{
    int df;
    int flow = 0;
   /* vector<bool> visited(net.size());

    do
    {
        for(int i = 0; i < visited.size(); i++) visited[i] = false;
        df = findPath(net, visited, source, sink, INF);
        flow += df;
    }while(df != 0);

   return flow;*/

    for(int flow = 0;;)
    {
        vector<bool> use(net.size());
        int df = findPath(net, use,source,sink, INF);
        if(df == 0)
            return flow;
        flow += df;
    }
}
